<?php

const VERSION='3.0.1';

session_start();
//error_reporting(E_ERROR);
//ini_set('display_errors', 'On');
$formats=loadFormats();

$opt_params=[
	'param_operators' => [
		'label' => 'Operators',
		'long_label'=>'Operators (your call if single op)',
		'cablabel' => 'OPERATORS',
		'type' => 'text'
	],
	'param_name' => [
		'label' => 'Name',
		'long_label' => 'Your name',
		'type' => 'text',
		'cablabel' => 'NAME',
	],
	'param_email' => [
		'label' => 'Email',
		'long_label' => 'Email address of entrant',
		'type' => 'text',
		'cablabel' => 'EMAIL',
		'options' => []
	],
	'param_arrl_section'=>[
		'label'=>'ARRL Section',
		'cablabel'=>'ARRL-SECTION',
		'type'=>'text'
	],
	'param_club' => [
		'label' => 'Club',
		'type' => 'text',
		'cablabel'=>'CLUB'
	],
	'param_claimed_score' => [
		'label' => 'Claimed Score',
		'type' => 'text',
		'cablabel'=>'CLAIMED-SCORE',
	],
	'param_contest' => [
		'label' => 'Contest',
		'type' => 'text',
		'cablabel' => 'CONTEST',
	],
	'param_soapbox' => [
		'label' => 'Soapbox',
		'type' => 'text',
		'cablabel' => 'SOAPBOX',
	],
	'param_certificate' => [
		'label' => 'Certificate',
		'long_label' => 'Whether you are requesting a certificate sent by postal mail',
		'type' => 'select',
		'cablabel' => 'CERTIFICATE',
		'options' => ['YES'=>'Yes', 'No'=>'No']
	],

	'param_grid_locator' => [
		'label' => 'Grid locator',
		'long_label'=>'Grid square from where station was operating',
		'type' => 'text',
		'cablabel' => 'GRID-LOCATOR',
	],
	'param_location' => [
		'label' => 'Location',
		'long_label' => 'Location from where station was operating',
		'type' => 'text',
		'cablabel' => 'LOCATION',
	],
	'param_category' => [
		'label' => 'Category',
		'cablabel' => 'CATEGORY',
		'type' => 'text',
	],
	'param_category_assisted' => [
		'label' => 'Category Assisted',
		'type' => 'select',
		'cablabel' => 'CATEGORY-ASSISTED',
		'options' => ['ASSISTED' => 'Assisted', 'NON-ASSISTED' => 'Non-assisted']
	],
	'param_category_band' => [
		'label' => 'Category Band',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-BAND',
		'options' => [
			'ALL'=>'ALL',
			'160M'=>'160M',
			'80M'=>'80M',
			'40M'=>'40M',
			'20M'=>'20M',
			'15M'=>'15M',
			'10M'=>'10M',
			'6M'=>'6M',
			'4M'=>'4M',
			'2M'=>'2M',
			'222'=>'222',
			'432'=>'432',
			'902'=>'902',
			'1.2G'=>'1.2G',
			'2.3G'=>'2.3G',
			'3.4G'=>'3.4G',
			'5.7G'=>'5.7G',
			'10G'=>'10G',
			'24G'=>'24G',
			'47G'=>'47G',
			'75G'=>'75G',
			'122G'=>'122G',
			'134G'=>'134G',
			'241G'=>'241G',
			'Light'=>'Light',
			'VHF-3-BAND and VHF-FM-ONLY'=>'VHF-3-BAND and VHF-FM-ONLY'
		]
	],
	'param_category_mode' => [
		'label' => 'Category Mode',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-MODE',
		'options' => [
			'MIXED'=>'Mixed modes',
			'CW'=>'CW',
			'DIGI'=>'Digital',
			'FM'=>'FM',
			'RTTY'=>'RTTY',
			'SSB'=>'SSB',
		]
	],
	'param_category_operator' => [
		'label' => 'Category Operator',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-OPERATOR',
		'options' => [
			'SINGLE-OP'=>'SINGLE-OP',
			'MULTI-OP'=>'MULTI-OP',
			'CHECKLOG'=>'CHECKLOG'
		]
	],
	'param_category_power' => [
		'label' => 'Category Power',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-POWER',
		'options' => ['HIGH'=>'High','LOW'=>'Low','QRP'=>'QRP']
	],
	'param_category_station' => [
		'label' => 'Category Station',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-STATION',
		'options' => [
			'DISTRIBUTED'=>'Distributed',
			'FIXED'=>'Fixed',
			'MOBILE'=>'Mobile',
			'PORTABLE'=>'Portable',
			'ROVER'=>'Rover',
			'ROVER-LIMITED'=>'Rover (Limited)',
			'ROVER-UNLIMITED'=>'Rover (Unlimited)',
			'EXPEDITION'=>'Expedition',
			'HQ'=>'HQ',
			'SCHOOL'=>'School',
			'EXPLORER'=>'Explorer'
		]
	],
	'param_category_time' => [
		'label' => 'Category Time',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-TIME',
		'options' => [
			'6-HOURS'=>'6 hours',
			'8-HOURS'=>'8 hours',
			'12-HOURS'=>'12 hours',
			'24-HOURS'=>'24 hours'
		]
	],
	'param_category_transmitter' => [
		'label' => 'Category Transmitter',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-TRANSMITTER',
		'options' => [
		    'ONE'=>'One',
		    'TWO'=>'Two',
		    'LIMITED'=>'Limited',
		    'UNLIMITED'=>'Unlimited',
		    'SWL'=>'SWL'
		]
	],
	'param_category_overlay' => [
		'label' => 'Category Overlay',
		'long_label' => '',
		'type' => 'select',
		'cablabel' => 'CATEGORY-OVERLAY',
		'options' => [
		    'CLASSIC'=>'Classic',
		    'ROOKIE'=>'Rookie',
		    'TB-WIRES'=>'TB Wires',
		    'YOUTH'=>'Youth',
		    'NOVICE-TECH'=>'Novice Tech',
		    'OVER-50'=>'Over 50'
		]
	],



];


if ($_SERVER['REQUEST_METHOD']=='POST') {

	$cabrillo_lines=[];

	$cabrillo_lines[]='START-OF-LOG: 2.0';
	if (!empty($_POST['param_callsign'])) {
		$_SESSION['param_callsign'] = $_POST['param_callsign'];
		$cabrillo_lines[] = 'CALLSIGN: ' . $_POST['param_callsign'];
	}

	foreach ($opt_params as $name=>$param) {
		if (!empty($_POST[$name])) {
			$_SESSION[$name] = $_POST[$name];
			$cabrillo_lines[] = $param['cablabel'].': ' . $_POST[$name];
		}
	}

	if (empty($_POST['contents'])) {
		if (empty($_FILES['adiffile']['tmp_name'])) exit("Your file was not uploaded<br><a href=\"index.php\">Go back</a>");
		$contents=$orig_contents=file_get_contents($_FILES['adiffile']['tmp_name']);
	} else {
		$contents=$orig_contents=$_POST['contents'];
	}
	$contents=str_replace(["\n","\t","\r"],'',$contents);

	//remove all non-ascii characters
	$contents = preg_replace('/[^[:ascii:]]/', '', $contents);
	$orig_contents = preg_replace('/[^[:ascii:]]/', '', $orig_contents);

	if (stripos($contents, '<EOH>')!==false) {
		$contents=preg_replace('/(^.*\<EOH\>)/', '', $contents);
	}

	$source_fields=[];
	$raw_qsos=[];

	if (!preg_match('/<eor>/i', $contents)) {
		exit('This file doesn\'t seem to be in ADIF format. Please go back, select a different file, and try again<br><br><a href="index.php">Go back</a>');
	}
	
	$qsos=preg_split("/<eor>/i", $contents);

	$cabrillo_lines[]='CREATED-BY: adif2cabrillo.com version '.VERSION;

	$use_format=$formats[(int)$_POST['format']];
	if (!stripos($use_format['line1'], '-----')) {
		$cabrillo_lines[] = $use_format['line1'];
	}

	if (!empty($_POST['action']) && $_POST['action']=='preview') {
		//show header descriptions in preview mode
		$cabrillo_lines[] = $use_format['line2'];
		$cabrillo_lines[] = $use_format['line3'];
	}
	foreach ($qsos as $qso) {
		$qso_fields = [];
		$fields_raw=explode("<",$qso);
		foreach ($fields_raw as $field_raw) {
			$parts = explode('>', $field_raw);
			if (empty($parts[1])) continue;

			$col=strtoupper(preg_replace('/(:.*)/', '', $parts[0]));
			$qso_fields[strtoupper($col)] = trim($parts[1]);

			$source_fields[$col]=$col;
		}
	
		$raw_qsos[]=$qso_fields;
		if (empty($qso_fields['FREQ'])) continue;

		$freq=str_replace([','], '', $qso_fields['FREQ']);
		switch ($qso_fields['MODE']) {
			case 'CW':
				$mode='CW';
				break;
			case 'FM':
				$mode='FM';
				break;
			case 'SSB':
			case 'LSB':
			case 'USB':
				$mode='PH';
				break;
			case 'RTTY':
				$mode = 'RY';
				break;
			default:
				//everything else is digital
				$mode = 'DG';
				break;
		}

		//set the sent exchange
		$sentstr='';
		if (!empty($_POST['exch_sent_field'])) {
			if ($_POST['exch_sent_field']=='atext') {
				$sentstr=$_POST['exch_sent_field_text'];
				foreach ($qso_fields as $check_field=>$val) {
					$sentstr=str_ireplace('@'.$check_field.'@', $val, $sentstr);
				}
			} else if (!empty($qso_fields[strtoupper($_POST['exch_sent_field'])])) {
				$sentstr=$qso_fields[strtoupper($_POST['exch_sent_field'])];
			}
		}
		$sentstr=trim($sentstr);

		//set the received exchange
		$rcvdstr = '';
		if (!empty($_POST['exch_rcvd_field'])) {
			if ($_POST['exch_rcvd_field'] == 'atext') {
				$rcvdstr = $_POST['exch_rcvd_field_text'];
				foreach ($qso_fields as $check_field=>$val) {
					$rcvdstr=str_ireplace('@'.$check_field.'@', $val, $rcvdstr);
				}
			} else if (!empty($qso_fields[strtoupper($_POST['exch_rcvd_field'])])) {
				$rcvdstr = $qso_fields[strtoupper($_POST['exch_rcvd_field'])];
			}
		}
		$rcvdstr=trim($rcvdstr);

		$date=$qso_fields['QSO_DATE'];
		$date=substr($date, 0, 4) . '-' . substr($date, 4, 2) . '-' . substr($date, 6, 2);
		$time=substr($qso_fields['TIME_ON'], 0, 4);

		$line='';
		$call_count=0; $rst_count=0; $exch_count=0;
		foreach ($use_format['format'] as $token) {
			switch ($token['token']) {
				case 'call':
					if ($call_count++==0) {
						//sending
						if (!empty($qso_fields['OPERATOR'])) {
							$cl = $qso_fields['OPERATOR'];
						} elseif (!empty($qso_fields['STATION_CALLSIGN'])) {
							$cl = $qso_fields['STATION_CALLSIGN'];
						} else {
							$cl = $_POST['param_callsign'];
						}
						$str = str_pad($cl, $token['length']);
					} else {
						//receiving
						$str = str_pad($qso_fields['CALL'], $token['length']);
					}
					break;
				case 'rst':
					if ($rst_count++ == 0) {
						//sending
						$str = str_pad($qso_fields['RST_SENT'], $token['length']);
					} else {
						//receiving
						$str = str_pad($qso_fields['RST_RCVD'], $token['length']);
					}
					break;
				case 'exch':
					if ($exch_count++ == 0) {
						//sending
						$str = str_pad($sentstr, $token['length']);
					} else {
						//receiving
						$str = str_pad($rcvdstr, $token['length']);
					}
					break;
				case 'freq':
					$str = str_pad(floor($freq * 1000), $token['length'], ' ', STR_PAD_LEFT);
					break;
				case 'mo':
					$str = str_pad($mode, $token['length']);
					break;
				case 'date':
					$str = str_pad($date, $token['length']);
					break;
				case 'time':
					$str = str_pad($time, $token['length']);
					break;
				case 't':
					$transmitter=1;
					if (!empty($qso_fields['MY_RIG']) && is_numeric($qso_fields['MY_RIG'])) {
						$transmitter=(int)$qso_fields['MY_RIG'];
					}
					$str = str_pad($transmitter, $token['length']);
					break;
				default:
					$str=str_pad($token['token'], $token['length']);
					break;
			}

			//truncate if too long
			$str=substr($str, 0, $token['length']);
			$line.=$str.' ';
		}
		$line=substr($line, 0, strlen($line)-1); //remove a single trailing space

		$cabrillo_lines[]=$line;

	}

	$cabrillo_lines[]='END-OF-LOG: 2.0';

	if (!isset($_POST['exch_sent_field'])) {
		$select_field='SENT';
		$field_name= 'exch_sent_field';
		require_once('select_field.php');
		exit;
	} else if (!isset($_POST['exch_rcvd_field'])) {
		$select_field = 'RECEIVED';
		$field_name= 'exch_rcvd_field';
		require_once('select_field.php');
		exit;
	} else {
		if (!empty($_POST['param_callsign'])) {
			$filename=$_POST['param_callsign'];
		} else {
			$filename='exported';
		}
		
		$body=implode("\n", $cabrillo_lines);

//		header('Content-Type: text/plain');
//		exit($body);

		if (empty($_POST['action']) || $_POST['action']<>'preview') {
			//don't force file transfer in preview mode
			header('Content-Description: File Transfer');
			header('Content-Type: application/cabrillo');
			header('Content-Disposition: attachment; filename="'.$filename.'.cbr"');
			header('Content-Transfer-Encoding: binary');
		}
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Pragma: public');
		header('Content-Length: ' . strlen($body));
		exit($body);

	}



}


//*** Default values
if (!empty($_POST['param_callsign'])) {
	$param_callsign = ($_POST['param_callsign']);
} elseif (!empty($_SESSION['param_callsign'])) {
	$param_callsign = ($_SESSION['param_callsign']);
} else {
	$param_callsign='';
}

foreach ($opt_params as $name=>$param) {
	if (!empty($_POST[$name])) {
		$default_values[$name] = ($_POST[$name]);
	} elseif (!empty($_SESSION[$name])) {
		$default_values[$name] = ($_SESSION[$name]);
	} else {
		$default_values[$name] = '';
	}
}





?><!DOCTYPE html>
<html lang="en">
<head>

	<!-- Basic Page Needs
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<meta charset="utf-8">
	<title>ADIF2Cabrillo -> Online Amateur Radio Log Format Conversion Utility</title>
	<meta name="description" content="">
	<meta name="author" content="">

	<!-- Mobile Specific Metas
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<!-- FONT
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link href="//fonts.googleapis.com/css?family=Raleway:400,300,600" rel="stylesheet" type="text/css">

	<!-- CSS
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link rel="stylesheet" href="css/normalize.css">
	<link rel="stylesheet" href="css/skeleton.css">

	<!-- Favicon
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link rel="icon" type="image/png" href="images/favicon.png">

</head>
<body>

<!-- Primary Page Layout
–––––––––––––––––––––––––––––––––––––––––––––––––– -->
<div class="container">
	<h1>ADIF 2 Cabrillo version <?php echo VERSION ?></h1>
	<div class="row">
		<div class="one-half column" style="margin-top: 10%">
			<h4>Convert ADIF to Cabrillo Format</h4>
			<h5>by KD9MJV</h5>
			<p>Have an ADIF file from amateur radio contesting, but the contest you want to enter wants a
				Cabrillo-formatted file? This is the tool that you need. Now you can export
				ADIF logs from popular ham radio loggers like HAMRS and convert them into a usable format
				with no extra software downloads needed. </p><p>I created this tool as a fast and easy online method
				to get the log format you need. Since there is nothing to install, this also is great for MacOS as
				a CabConverter replacement.
				</p>

		</div>
	</div>

	<div class="row">
		<div class=" column" style="margin-top: ">

			<form method="POST" action="index.php" enctype="multipart/form-data" onsubmit="return validate()">

				<hr>
				<fieldset>
					<legend>ADIF File</legend>
					<input type="file" name="adiffile">
				</fieldset>

				<fieldset>
					<legend>Format</legend>
					<select name="format">
					<?php foreach ($formats as $index=>$format) { ?>
						<option value="<?php echo $index ?>"><?php echo $format['name'] ?></option>
					<?php } ?>
					</select>
				</fieldset>
				
				<fieldset>
					<legend>Optional Header Parameters</legend>

						<label for="param_callsign">Your callsign</label>
						<input type="text" id="param_callsign" name="param_callsign" value="<?php echo htmlentities($param_callsign) ?>"></fieldset>

					<?php foreach ($opt_params as $name => $param) { ?>
						<div class="param-section">
							<a href="#">+ Add <?php echo $param['label'] ?></a><br>
							<div>
							<label for="<?php echo $name ?>"><?php echo ($param['long_label'] ?? $param['label']) ?></label>
							<?php if ($param['type']=='select') { ?>
								<select id="<?php echo $name ?>" name="<?php echo $name ?>">
									<option value=""></option>
									<?php foreach ($param['options'] as $n=>$opt) { ?>
									<option value="<?php echo htmlentities($n) ?>"><?php echo htmlentities($opt) ?></option>
									<?php } ?>
								</select>
							<?php } else { ?>
							<input type="text" id="<?php echo $name ?>" name="<?php echo $name ?>" value="<?php echo htmlentities($default_values[$name]) ?>"></fieldset>
							<?php } ?>
							</div>
						</div>
					<?php } ?>

				</fieldset>

				<br>

				<div class="row">
					<button>Convert</button>
				</div>

				<hr>

				<div class="row">
					<div class="one-half column" style="">
						<p>Note: I DO NOT store any of your logging data.</p>

						<p>If you have issues, questions, or bug reports, please email a copy of your ADIF file along with all relevant
							information using this form:</p>


						<div>
							<a href="#" onclick="document.getElementById('contact-form').style='';this.style='display:none';return false;">Click HERE to contact me</a>
						</div>
						<p style="display: none" id="contact-form">

							<script src="https://www.cognitoforms.com/f/seamless.js"
								   data-key="mwxpniUAdEOHo4FH4jn4Kg" data-form="1"></script>
						</p>

					</div>
				</div>

				<div class=row>
				<div>
				Want to download the source code? Click <a href="/a2csource.zip">here</a>
				</div>
				</div>
				
			</form>

		</div>
	</div>

</div>

<script>
	function validate() {
		let file=document.querySelector('input[type=file]');
		if (file.files.length==0) {
			alert("Please attach your file before submitting");
			return false;
		}
		return true;
	}

	let divs=document.getElementsByClassName('param-section');
	for (let i=0; i<divs.length; i++) {
		let a = divs[i].querySelector('a');
		let inner_div = divs[i].querySelector('div');
		if (divs[i].querySelector('input,select').value!='') {
			a.style='display:none';
		} else {
			a.style='';
			inner_div.style='display:none';
		}
		a.onclick=function () {
			inner_div.style='';
			a.style = 'display:none';
			return false;
		}
	}
</script>

<style>
body {
	background:#fff;	
}
button,input[type="submit"] {
	background-color: #0060df;
	color: #fff;
}
input {
	margin-bottom: 0.5em;
}
</style>

<!-- End Document
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
</body>
</html>

<?php

function debug($arr) {
	echo '<br><pre>';
	print_r($arr);
	echo '</pre><br>';
}
function loadFormats() {
	//formats.dat from http://www.contestlogchecker.com/cabrillo-templates.html
	$data=file('formats.dat');
	
	$output=[];
	
	$current_name=null;
	$current_line1=null;
	$current_line2=null;
	$current_line3=null;
	$skip_next=0;

	foreach ($data as $line) {

		$line=rtrim($line, " \n");
		if (!$line || preg_match('/^[0-9]+$/', $line)) continue;

		if ($skip_next) {
			if (preg_match('/^(QSO|QTC)/', $line)) continue;
			$skip_next--;
		}
		if (!$current_name) {
			if (preg_match('/----/', $line)) {
				//no title
				$skip_next=2;
				continue;
			}
			$current_name=$line;
		} else if (!$current_line1) {
			$current_line1=$line;
		} else if (!$current_line2) {
			$current_line2=$line;
		} else if (!$current_line3) {
			$current_line3=$line;
			//wrap up
			$output[]=[
				'name'=>$current_name,
				'line1'=>$current_line1,
				'line2'=>$current_line2,
				'line3'=>$current_line3,
				'format'=>parseFormat($current_line2)
			];
			$current_name=null;
			$current_line1=null;
			$current_line2=null;
			$current_line3=null;
			$skip_next=1;
		}
	}

	return $output;
}
function parseFormat($text_line) {
	$output_format=[];
	$adj_line=preg_replace("/[ ]+/", ' ', $text_line);
	$tokens=explode(" ", $adj_line);

	$text_line=preg_replace('/\bt\b/', '^', $text_line);

	$position=0;
	$length=0;
	foreach ($tokens as $ctr=>$token) {
		if ($ctr+1<count($tokens)) {
			$chk=$tokens[$ctr + 1];
			if ($chk=='t') $chk='^';
			$next_token_position=strpos($text_line, $chk, $position+$length);
		} else {
			//last token
			$next_token_position=strlen($text_line);
		}
		
		$position=strpos($text_line, $token, $position);
		
		$length = $next_token_position - $position - 1;
		
		$output_format[]=[
			'token'=>$token,
			'length'=>$length,
			'position'=>$position,
			'next_token_position'=>$next_token_position,
			'length'=>$length
		];
		
	}
	return $output_format;
}
