<!DOCTYPE html>
<html lang="en">
<head>

	<!-- Basic Page Needs
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<meta charset="utf-8">
	<title>ADIF2Cabrillo.com</title>
	<meta name="description" content="">
	<meta name="author" content="">

	<!-- Mobile Specific Metas
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<meta name="viewport" content="width=device-width, initial-scale=1">

	<!-- FONT
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link href="//fonts.googleapis.com/css?family=Raleway:400,300,600" rel="stylesheet" type="text/css">

	<!-- CSS
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link rel="stylesheet" href="css/normalize.css">
	<link rel="stylesheet" href="css/skeleton.css">

	<!-- Favicon
	–––––––––––––––––––––––––––––––––––––––––––––––––– -->
	<link rel="icon" type="image/png" href="images/favicon.png">

</head>
<body>

<!-- Primary Page Layout
–––––––––––––––––––––––––––––––––––––––––––––––––– -->
<div class="container">
	<div class="row">
		<div class="one-half column" style="margin-top: 10%">
			<form method="post" action="index.php" id="exch-form">
				<input type="hidden" name="contents" value="<?php echo htmlentities($orig_contents) ?>">
				<?php foreach ($_POST as $a=>$v) { ?>
					<?php if (preg_match('/^param_/', $a)) { ?>
						<input type="hidden" name="<?php echo $a ?>" value="<?php echo htmlentities($v) ?>">
					<?php } ?>
				<?php } ?>
				<input type="hidden" name="format" value="<?php echo htmlentities($_POST['format']) ?>">

				<?php if (isset($_POST['exch_sent_field'])) { ?>
					<input type="hidden" name="exch_sent_field" value="<?php echo htmlentities($_POST['exch_sent_field']) ?>">
					<input type="hidden" name="exch_sent_field_text" value="<?php echo htmlentities($_POST['exch_sent_field_text']) ?>">
				<?php } ?>

				<h4>What is the part of the exchange you are <?php echo ($select_field=='SENT' ? 'SENDING' : 'RECEIVING') ?>?</h4>
	
				<div id="exchange-options">
					<a href="#" id="exchange-field">I'm using a single field</a><br>
					<a href="#" id="exchange-string">I'm using multiple fields combined or a custom string</a><br>
					<a href="#" id="exchange-nothing">I want to leave the field blank</a>
				</div>
	
				<!-- nothing -->
				<input type="radio" id="exch-select-nothing" name="<?php echo $field_name ?>" value="anull" style="display:none">
				<!-- text -->
				<input type="radio" id="exch-select-text" name="<?php echo $field_name ?>" value="atext" style="display:none">
				
	
				<div id="exchange-field-list" style="display:none">
					<?php foreach ($source_fields as $source_field) { ?>
						<?php
						if (in_array($source_field,['FREQ','FREQ_RX','QSO_DATE','RST_RCVD','RST_SENT','BAND','CALL'])) {
							continue;
						}
						?>
						<div>
						<input style="display:inline" type="radio" name="<?php echo $field_name ?>" value="<?php echo htmlentities($source_field) ?>"> <label style="display:inline"><?php echo htmlentities($source_field) ?></label>
						<?php /*(Examples:
						<?php $ctr=0; ?>
						<?php foreach ($raw_qsos as $raw_qso) { ?>
							<?php
							if (!empty($raw_qso[$source_field])) {
								echo htmlentities($raw_qso[$source_field]);
								if ($ctr!=3) echo ', ';
								if (++$ctr > 3) break;
							}
							?>
						<?php } ?>)*/ ?>
						</div>
					<?php } ?>
				</div>
	
				
				<div id="exchange-string-list" style="display:none">
					<label for="exch-sent-field">The text to use:</label>
					<input type="text" name="exch_<?php echo ($select_field=='SENT' ? 'sent' : 'rcvd') ?>_field_text" id="exch-use-field" value="" placeholder="You can type text or add fields below" style="width:330px">
					<div>
						<b>Click a field to add it to the above</b><br><br>
						<ul id="add-fields">
						<?php foreach ($source_fields as $source_field) { ?>
							<?php
							if (in_array($source_field, ['FREQ', 'FREQ_RX', 'QSO_DATE', 'RST_RCVD', 'RST_SENT', 'BAND', 'CALL'])) {
								continue;
							}
							?>
							<li>
								<a href="#" onclick="return addField('<?php echo $source_field ?>')"><?php echo $source_field ?></a>
									(examples: <?php foreach ($raw_qsos as $raw_qso) { ?>
										<?php
										if (!empty($raw_qso[$source_field])) {
											echo htmlentities($raw_qso[$source_field]);
											if (++$ctr > 3) break;
										}
										?>
									<?php } ?>)
							</li>
						<?php } ?>
						</ul>
					</div>
				</div>
				
				<input type="submit" value="Continue &gt;" id="exchange-submit" style="display:none">
			</form>

			<script>
					document.getElementById('exchange-field').onclick=function () {
						document.getElementById('exchange-options').style='display:none';
						document.getElementById('exchange-field-list').style='';
						document.getElementById('exchange-submit').style='';
						return false;
					}
					document.getElementById('exchange-nothing').onclick=function () {
						document.getElementById('exch-select-nothing').checked=true;
						document.getElementById('exch-form').submit()
						return false;
					}
					document.getElementById('exchange-string').onclick=function () {
						document.getElementById('exchange-options').style='display:none';
						document.getElementById('exchange-string-list').style='';
						document.getElementById('exchange-submit').style='';
						document.getElementById('exch-select-text').checked=true;
						return false;
					}
					function addField(field) {
						let v=document.getElementById('exch-use-field');
						v.value=v.value + '@'+field+'@ ';
						v.focus();
						updatePreview();
						return false;
					}
			</script>

		</div>
	</div>

	<div style="height:500px;"></div>
</div>

<div id="preview">
	<h2>Preview</h2>
	<div id="preview-content">
		Make your selections above to see the preview
	</div>
</div>

<script>
	let updatePreview=function () {
		let url = 'index.php';

		// Get all hidden input elements
		let hiddenInputs = document.querySelectorAll('input[type=hidden]');
		let params = new URLSearchParams();

		// Add 'action' parameter
		params.append('action', 'preview');

		// Add all hidden input values to params
		for (let input of hiddenInputs) {
			params.append(input.name, input.value);
		}

		let v = document.querySelector("form#exch-form input[name='exch_sent_field']:checked");
		if (!params.has('exch_sent_field')) {
			params.append('exch_sent_field', (v ? v.value : ''));
		}
		v=document.querySelector("form#exch-form input[name='exch_rcvd_field']:checked");
		if (!params.has('exch_rcvd_field')) {
			params.append('exch_rcvd_field', (v ? v.value : ''));
		}

		v = document.querySelector('input[name=exch_sent_field_text]');
		if (!params.has('exch_sent_field_text')) {
			params.append('exch_sent_field_text', (v ? v.value : ''));
		}
		v = document.querySelector('input[name=exch_rcvd_field_text]');
		if (txt && !params.has('exch_rcvd_field_text')) {
			params.append('exch_rcvd_field_text', (v ? v.value : ''));
		}

		let fetchData = {
			method: 'POST',
			headers: {
				'Content-Type': 'application/x-www-form-urlencoded',
			},
			body: params
		}

		fetch(url, fetchData)
			.then(response => {
				if (!response.ok) {
					throw new Error("HTTP error " + response.status);
				}
				return response.text();
			})
			.then(data => {
				// saving data to variable here
				let output = data;
				document.getElementById('preview-content').innerText=output;
			})
			.catch(function () {
				console.log("An error occurred while attempting to fetch the resource.");
			});
	}
	let buttons=document.querySelectorAll('input[type=radio]');
	for (let i in buttons) {
		buttons[i].onclick=updatePreview;
	}
	let txt=document.getElementById('exch-use-field');
	if (txt) {
		txt.onkeyup=updatePreview;
	}
</script>


<style>
	#preview-content {
		font-family: 'Courier New', Courier, monospace;
		height:64%;
		overflow-y:scroll;
		white-space: pre-wrap;
		background:#ccc;
	}
	#preview {
		position: fixed;
		bottom:0;
		left:0;
		background:#FFF;
		width:100%;
		height:30%;
		border-top:1px dashed #333;
	}
#add-fields ul {
	margin:0;
}
#add-fields li {
	margin:0;
}
</style>

<!-- End Document
  –––––––––––––––––––––––––––––––––––––––––––––––––– -->
</body>
</html>

<?php
